unit fm_i332;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls;

TYPE TGetI332Handle = FUNCTION: INTEGER of object;
type
  TfmI332 = class(TFrame)
    Label1: TLabel;
    lblIFCErr: TLabel;
    RichEdit1: TRichEdit;
  private
    { Private-Deklarationen }
    FOnCreate: TNotifyEvent;
    FOnDestroy: TNotifyEvent;
    FOnGetI332Handle: TGetI332Handle;
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure AfterConstruction; override;
    procedure BeforeDestruction; override;
    PROCEDURE DoDisp; virtual;
    FUNCTION FindAxComp(VAR AxComp: TComponent; TAxComp: TComponentClass; BaseName: String; AchsNr: INTEGER): BOOLEAN;
    FUNCTION DispIFCErr(IFCErr: LONGINT): LONGINT;
    property OnGetI332Handle: TGetI332Handle read FOnGetI332Handle write FOnGetI332Handle;
  published
    property OnCreate: TNotifyEvent read FOnCreate write FOnCreate stored TRUE;
    property OnDestroy: TNotifyEvent read FOnDestroy write FOnDestroy stored TRUE;
  protected
    FUNCTION I332Handle: INTEGER;
  end;

implementation

uses i332_def, i332_ifc;

{$R *.dfm}

constructor TfmI332.Create(AOwner: TComponent);
BEGIN
  inherited Create(AOwner);
END;

procedure TfmI332.AfterConstruction;
BEGIN
  inherited AfterConstruction;
END;

procedure TfmI332.BeforeDestruction;
BEGIN
  inherited BeforeDestruction;
END;

destructor TfmI332.Destroy;
BEGIN
  I332Restart(I332Handle,icRestart3);
  inherited Destroy;
END;

FUNCTION TfmI332.I332Handle: INTEGER;
BEGIN
  IF Assigned(FOnGetI332Handle)
  THEN Result := FOnGetI332Handle
  ELSE Result := -1;
END;

PROCEDURE TfmI332.DoDisp;
BEGIN
END;

FUNCTION TfmI332.FindAxComp(VAR AxComp: TComponent; TAxComp: TComponentClass; BaseName: String; AchsNr: INTEGER): BOOLEAN;
BEGIN
  AxComp := FindComponent(BaseName+IntToStr(AchsNr));
  Result := Assigned(AxComp) AND (AxComp.ClassType = TAxComp);
END;

FUNCTION TfmI332.DispIFCErr(IFCErr: LONGINT): LONGINT;
VAR s: String;
BEGIN
  Result := IFCErr;
  lblIFCErr.Visible := IFCErr <> 0;
  IF lblIFCErr.Visible THEN BEGIN
    SetLength(s,I332GetIFCErrString(IFCErr,NIL,0)); // Lnge holen
    I332GetIFCErrString(IFCErr,@s[1],Length(s));    // String holen
    lblIFCErr.Caption := s;
  END;
END;

end.
