unit fm_I332IPL;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, fm_i332, ComCtrls;

type
  TfmI332IPL = class(TfmI332)
    edtPos0: TLabeledEdit;
    edtPos1: TLabeledEdit;
    edtPos2: TLabeledEdit;
    edtPos3: TLabeledEdit;
    edtPos4: TLabeledEdit;
    edtPos5: TLabeledEdit;
    edtPos6: TLabeledEdit;
    edtPos7: TLabeledEdit;
    rgIPLMode: TRadioGroup;
    rgX: TRadioGroup;
    rgY: TRadioGroup;
    cbAbs: TCheckBox;
    cbPotiOff: TCheckBox;
    edtFeed: TLabeledEdit;
    edtMPX: TLabeledEdit;
    edtMPY: TLabeledEdit;
    btnIPL: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    procedure rgIPLModeClick(Sender: TObject);
    procedure btnIPLClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
  end;

implementation

uses i332_def, i332_ifc;

{$R *.dfm}

constructor TfmI332IPL.Create(AOwner: TComponent);
VAR AxLbls: TAxLbls;
    i: INTEGER;
    edtPos: TLabeledEdit;
BEGIN
  inherited Create(AOwner);
  I332GetAxLabels(I332Handle,AxLbls);
  FOR i := 0 TO Axes-1 DO BEGIN
    IF FindAxComp(TComponent(edtPos),TLabeledEdit,'edtPos',i)
    THEN edtPos.EditLabel.Caption := '&'+AxLbls[i];

    rgX.Items[i] := AxLbls[i];
    rgY.Items[i] := AxLbls[i];
  END;
END;

procedure TfmI332IPL.rgIPLModeClick(Sender: TObject);
begin
  rgX.Enabled := rgIPLMode.ItemIndex > 0;
  rgY.Enabled := rgIPLMode.ItemIndex > 0;
  edtMPX.Enabled := rgIPLMode.ItemIndex > 0;
  edtMPY.Enabled := rgIPLMode.ItemIndex > 0;
end;

procedure TfmI332IPL.btnIPLClick(Sender: TObject);
VAR AxisArray: TAxisArray;
    i: INTEGER;
    edtPos: TLabeledEdit;
    F: INTEGER;
    Flags: INTEGER;
    s: String;
    mpx,mpy: INTEGER;
    IFCErr: INTEGER;
begin
  IF rgIPLMode.ItemIndex = -1
  THEN raise Exception.Create('Interpolations-Modus auswhlen');

  // Positionsdaten aller Achsen einsammeln:
  FOR i := 0 TO Axes-1 DO BEGIN
    AxisArray[i] := UndefL;    // Achsposition undefiniert
    IF FindAxComp(TComponent(edtPos),TLabeledEdit,'edtPos',i)
    THEN BEGIN
      s := Trim(edtPos.Text);
      IF s = '' THEN Continue; // leere Felder ignorieren
                               // Achsposition weiterhin undefiniert:
                               // --> wird nicht verfahren
      AxisArray[i] := StrToInt(s);
    END;
  END;

  // Vorschub:
  F := StrToInt(edtFeed.Text);

  // relativ/absolut:
  IF cbAbs.Checked THEN Flags := fAbs ELSE Flags := fRel;

  IFCErr := 0;

  IF rgIPLMode.ItemIndex = 0 THEN BEGIN    // Linear-Interpolation
    IFCErr := I332DoIPLLin(I332Handle,
                           Axes,AxisArray,
                           F,Flags);
  END ELSE BEGIN                           // Kreis-Interpolation
    // Mittelpunktdaten:
    mpx := StrToInt(Trim(edtMPX.Text));
    mpy := StrToInt(Trim(edtMPY.Text));

    IF rgIPLMode.ItemIndex = 1 THEN BEGIN  // Kreis-Interpolation UZS
      IFCErr := I332DoIPLCW(I332Handle,
                            Axes,AxisArray,
                            F,Flags,
                            rgX.ItemIndex,rgY.ItemIndex,mpx,mpy);

    END ELSE BEGIN                         // Kreis-Interpolation GZS
      IFCErr := I332DoIPLCCW(I332Handle,
                             Axes,AxisArray,
                             F,Flags,
                             rgX.ItemIndex,rgY.ItemIndex,mpx,mpy);
    END;
  END;

  // ggf. Fehler anzeigen:
  DispIFCErr(IFCErr);
end;

end.
