unit fm_i332Hnd;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, fm_i332, ComCtrls;

type
  TfmI332Hnd = class(TfmI332)
    cbAchsen: TComboBox;
    edtFeed: TLabeledEdit;
    btnMinus: TBitBtn;
    btnPlus: TBitBtn;
    rgVMode: TRadioGroup;
    cbPotiOff: TCheckBox;
    cbLSOff: TCheckBox;
    Label2: TLabel;
    procedure btnMinusMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnPlusMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnHndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
    PROCEDURE DoSFHand(Rtg: INTEGER);
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
  end;

implementation

uses i332_def, i332_ifc;

{$R *.dfm}

constructor TfmI332Hnd.Create(AOwner: TComponent);
VAR AxLbls: TAxLbls;
    i: INTEGER;
BEGIN
  inherited Create(AOwner);
  I332GetAxLabels(I332Handle,AxLbls);
  cbAchsen.Clear;
  FOR i := 0 TO Axes-1 DO cbAchsen.Items.Add(AxLbls[i]);
  cbAchsen.ItemIndex := 0;
END;

PROCEDURE TfmI332Hnd.DoSFHand(Rtg: INTEGER);
VAR sfMode: WORD;
    V: INTEGER;
BEGIN
  // Daten aus den einzelnen Eingabe-Elementen einsammeln:

  // Geschwindigkeit:
  try V := StrToInt(edtFeed.Text); except exit; end;
  V := V*Rtg;

  // Modus:
  CASE rgVMode.ItemIndex OF
    0: sfMode := sfVMax; // in %
    1: sfMode := sfVCmd; // in mm/min
    ELSE Exit;
  END;

  IF cbPotiOff.Checked THEN sfMode := sfMode or sfPotiOff;
  IF cbLSOff.Checked   THEN sfMode := sfMode or sfLSOff;

///  sfMode := sfMode or $0E00;

  // Sonderfunktion setzen:
  I332DoAxisHand(I332Handle,cbAchsen.ItemIndex,V,sfMode);

  // Startbits setzen:
  I332ZyklusStart(I332Handle);
END;

procedure TfmI332Hnd.btnMinusMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DoSFHand(-1);
end;

procedure TfmI332Hnd.btnPlusMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DoSFHand(+1); 
end;

procedure TfmI332Hnd.btnHndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  I332DoAxisHand(I332Handle,cbAchsen.ItemIndex,0,sfBreak);
  I332ZyklusStop(I332Handle);
end;

end.
