unit frm_i332Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls, fm_I332;

VAR I332Handle: INTEGER = -1;

type
  TfrmI332Main = class(TForm)
    Panel1: TPanel;
    rgIFC: TRadioGroup;
    GroupBox2: TGroupBox;
    edtIFC: TEdit;
    udIFC: TUpDown;
    btnInit: TButton;
    Label1: TLabel;
    Panel2: TPanel;
    VIstLbl: TLabel;
    SIstLbl: TLabel;
    lblDelay: TLabel;
    lblPos: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    rgRestart: TRadioGroup;
    btnStart: TBitBtn;
    btnStop: TBitBtn;
    btnRestart: TBitBtn;
    GroupBox1: TGroupBox;
    cbSSB: TCheckBox;
    cbSFB: TCheckBox;
    cbErrB: TCheckBox;
    cbLSB: TCheckBox;
    cbFEB: TCheckBox;
    cbFEMaxB: TCheckBox;
    cbBNEB: TCheckBox;
    cbPos: TComboBox;
    Timer1: TTimer;
    Panel3: TPanel;
    btnClose: TBitBtn;
    btnTstDlg: TButton;
    btnCfgDlg: TButton;
    tbPoti: TTrackBar;
    lblPoti: TLabel;
    gbDemo: TGroupBox;
    rbRef: TRadioButton;
    rbHnd: TRadioButton;
    rbIPL: TRadioButton;
    rbSP: TRadioButton;
    rbAS: TRadioButton;
    rbJS: TRadioButton;
    rbHR: TRadioButton;
    rbIO: TRadioButton;
    rbCNC: TRadioButton;
    rbOff: TRadioButton;
    rbBuffer: TRadioButton;
    I332ErrLbl: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnCfgDlgClick(Sender: TObject);
    procedure btnInitClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnRestartClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnTstDlgClick(Sender: TObject);
    procedure rbDemoClick(Sender: TObject);
  private
    { Private-Deklarationen }
    INIFile: String;
    fmI332: TfmI332;
    PROCEDURE DoDisp;
    PROCEDURE EnableDisplay(Enable: BOOLEAN);
  public
    { Public-Deklarationen }
  end;

var
  frmI332Main: TfrmI332Main;

implementation

{$R *.DFM}

uses INIFiles, i332_def, i332_ifc,
     fm_i332Ref,
     fm_I332IPL,
     fm_i332JS,
     fm_I332SP,
     fm_I332AS,
     fm_I332IO,
     fm_i332HR,
     fm_i332Hnd,
     fm_i332CNC,
     fm_i332Buffer
     ;

procedure TfrmI332Main.FormCreate(Sender: TObject);
begin
  I332Handle := -1;
  Caption := 'I332-Demo-Programm - DLL-Version: '+IntToHex(I332DLLVersion,8);
  INIFile := ExtractFilePath(ParamStr(0))+'i332.ini'; // im Applikationsverzeichnis
  Timer1.Enabled := FALSE;

  I332ErrLbl.Caption := '';

  WITH TINIFile.Create(ChangeFileExt(ParamStr(0),'.INI')) DO try
    rgIFC.ItemIndex := ReadInteger('IFC','IFC_ID',rgIFC.ItemIndex);
    udIFC.Position  := ReadInteger('IFC','IFC_NR',udIFC.Position);
  finally
    Free;
  END;

  Application.OnActivate := FormActivate; // gelegentlich wird sonst die Form nur unvollstndig neu gezeichnet
end;

procedure TfrmI332Main.FormDestroy(Sender: TObject);
begin
  IF Assigned(fmI332) THEN fmI332.Free;
  fmI332 := NIL;
  I332IFCDone(I332Handle);
  I332Handle := -1;
end;

procedure TfrmI332Main.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WITH TINIFile.Create(ChangeFileExt(ParamStr(0),'.INI')) DO try
    WriteInteger('IFC','IFC_ID',rgIFC.ItemIndex);
    WriteInteger('IFC','IFC_NR',udIFC.Position);
  finally
    Free;
  END;
end;

procedure TfrmI332Main.btnCloseClick(Sender: TObject);
begin
  IF Assigned(fmI332) THEN BEGIN
    fmI332.Free;
    fmI332 := NIL;
    rbOff.Checked := TRUE;
  END
  ELSE Close;
end;

procedure TfrmI332Main.btnCfgDlgClick(Sender: TObject);
VAR x: LONGINT;
begin
  I332ExecCfgDlg(I332Handle,@INIFile[1]);
end;

procedure TfrmI332Main.btnTstDlgClick(Sender: TObject);
begin
  I332ExecTstDlg(I332Handle,1);
end;

procedure TfrmI332Main.btnInitClick(Sender: TObject);
  PROCEDURE InitIFC(AIFCMode,AIFCPara: INTEGER);
  VAR I332Info: TI332Info;
      s: String;
  BEGIN
    I332Handle := I332IFCInit(AIFCMode,AIFCPara);
    IF I332Handle < 0
    THEN Panel1.Caption := 'TimeOut I332'
    ELSE BEGIN
      I332GetInfo(I332Handle,I332Info);
      SetLength(s,513);                                  // 513 Byte Speicher reservieren
      SetLength(s,I332GetVerStr(I332Handle,@s[1],513));  // Versionsstr. holen und tatschliche Lnge anpassen
                                                         // nicht ganz astrein, da I332GetVerStr u.U.
                                                         // eine neg. Fehlernummer zurckliefert
      Panel1.Caption := s + ' - I332ID: ' + I332Info.I332ID;

      // Maschinendaten bertragen
      I332XmtCFG(I332Handle,@INIFile[1]);
(*
      I332SetAchsReg(I332Handle,icSetAP+apChar,0,$01000201);
      I332SetAchsReg(I332Handle,icSetAP+apChar,1,$02000201);
      I332SetAchsReg(I332Handle,icSetAP+apChar,2,$00000201);
      I332SetAchsReg(I332Handle,icSetAP+apChar,3,$03000101);
      I332SetAchsReg(I332Handle,icSetAP+apChar,4,$04000101);
      I332SetAchsReg(I332Handle,icSetAP+apChar,5,$05000101);
      I332SetAchsReg(I332Handle,icSetAP+apChar,6,$06000101);
      I332SetAchsReg(I332Handle,icSetAP+apChar,7,$07000101);

      I332Write2(I332Handle,icSetMP+$002D,$00000000);
* )
      I332SetAchsReg(I332Handle,icSetAP+apLSMax,0,100);

      I332Write0(I332Handle,icInitMP);
*)
    END;
  END;
begin
  EnableDisplay(FALSE);
  Panel1.Caption := 'Initialisierung'; Refresh;
  CASE rgIFC.ItemIndex OF
    0: InitIFC(imPCI,udIFC.Position);
    1: InitIFC(imCOM+udIFC.Position,0);
    2: InitIFC(imISA,0);
    3: InitIFC(imUSB,0);
    ELSE {sollte nicht vorkommen} BEGIN Panel1.Caption := 'ungltige Schnittstelle'; I332Handle := -1; END;
  END;
  Refresh;
  EnableDisplay(I332Handle >= 0);
end;

PROCEDURE TfrmI332Main.EnableDisplay(Enable: BOOLEAN);
BEGIN
  Timer1.Enabled := Enable;
END;

procedure TfrmI332Main.Timer1Timer(Sender: TObject);
BEGIN
  DoDisp;
  IF Assigned(fmI332) THEN fmI332.DoDisp;
END;

procedure TfrmI332Main.DoDisp;
  FUNCTION I332AxDisp: String;
  VAR i: INTEGER;
      icGet: WORD;
      AxisArray: TAxisArray;
  BEGIN
    CASE cbPos.ItemIndex OF
      0: icGet := icGetPos;          // Sollposition
      1: icGet := icGetPos0;         // Istposition
      2: icGet := icGetPIDFErr;      // Schleppfehler
      3: icGet := icGetSFV;          // Achsgeschwindigkeit
      ELSE icGet := icGetPos;
    END;
    I332GetAxArray(I332Handle,icGet,AxisArray);

    Result := '';
    FOR i := 0 TO Axes-1 DO
      IF cbPos.ItemIndex = 3
      THEN Result := Result + FormatFloat('#####0 mm/min',AxisArray[i]) + #13
      ELSE Result := Result + FormatFloat('###0.000 mm',AxisArray[i]/1000) + #13;
  END;

  function read1(cmd: word): word;
  begin
    i332read1(i332handle,cmd,result);
  end;
VAR i: INTEGER;
    I332Status: LONGINT;
begin
  lblPos.Caption := I332AxDisp;

  VIstLbl.Caption := FormatFloat('####0 mm/min',I332VIst(I332Handle));
  I332Read2(I332Handle,icGetSCur,i);
  SIstLbl.Caption := FormatFloat('####0 U/min',i);
  I332Read2(I332Handle,icGetWait,i);
  lblDelay.Caption := FormatFloat('###0.000 sec',i/1000);

  // Fehlerbits im Status berwachen:
  I332GetStatus(I332Handle,I332Status);
  IF I332Status and stLSF  <> 0 THEN I332ErrLbl.Caption := 'Endschalter';
  IF I332Status and stErrF <> 0 THEN I332ErrLbl.Caption := 'I332-Fehler';
  IF I332Status and stFEF  <> 0 THEN I332ErrLbl.Caption := 'max. Schleppfehler berschritten';
  IF  (I332ErrLbl.Caption <> '')
  AND (I332Status and (stLSF+stErrF+stFEF) = 0) THEN I332ErrLbl.Caption := '';

  cbSSB.Checked    := I332Status and stSSF    <> 0;
  cbSFB.Checked    := I332Status and stSFF    <> 0;
  cbErrB.Checked   := I332Status and stErrF   <> 0;
  cbLSB.Checked    := I332Status and stLSF    <> 0;
  cbFEB.Checked    := I332Status and stFEF    <> 0;
  cbFEMaxB.Checked := I332Status and stFEMaxF <> 0;
  cbBNEB.Checked   := I332Status and stBNEF   <> 0;

  i := I332GetIFCErr(I332Handle);
  IF i < 0 THEN Panel1.Caption := 'Interface-Fehler: '+IntToStr(i);

  I332Read2(I332Handle,icGetOvr,i);             // aktuelle Poti- oder Override-Wert
  tbPoti.Position := HiWord(i) * 100 DIV $8000; // Highword $8000 = 100%
  lblPoti.Caption := 'Poti / Override = '+IntToStr(tbPoti.Position)+'%';

  label2.caption := 'CNC - AM'+#13
                 +  IntToHex(Read1($D19F),4)+'-'+IntToHex(Read1($D19C),4)+#13
                 +  IntToHex(Read1($D1AF),4)+'-'+IntToHex(Read1($D1AC),4)+#13
                 +  IntToHex(Read1($D1BF),4)+'-'+IntToHex(Read1($D1BC),4)+#13
  ;
  label2.repaint;
end;

procedure TfrmI332Main.btnStartClick(Sender: TObject);
begin
  I332ZyklusStart(I332Handle);
end;

procedure TfrmI332Main.btnStopClick(Sender: TObject);
begin
  I332ZyklusStop(I332Handle);
end;

procedure TfrmI332Main.btnRestartClick(Sender: TObject);
// Zurcksetzen von Fehlermeldungen
// Lschen von Fahr-Auftrgen (Interpolation + Sonderfunktionen)
begin
  CASE rgRestart.ItemIndex OF
    0: I332Restart(I332Handle,icRestart1);
    1: I332Restart(I332Handle,icRestart2);
    2: I332Restart(I332Handle,icRestart3);
    3: I332Restart(I332Handle,icRestart5);
    4: I332Restart(I332Handle,icRestart11);
    5: I332Restart(I332Handle,icRestart12);
    6: I332Restart(I332Handle,icRestart13);
    7: I332Restart(I332Handle,icRestart14);
    8: I332Restart(I332Handle,icRestart15);
  END;
end;

procedure TfrmI332Main.FormActivate(Sender: TObject);
begin
  Refresh;
end;

procedure TfrmI332Main.rbDemoClick(Sender: TObject);
begin
  IF Assigned(fmI332) THEN BEGIN
    fmI332.Free;
    fmI332 := NIL;
  END;
  IF Sender = rbRef THEN fmI332 := TfmI332Ref.Create(Self)
  ELSE
  IF Sender = rbHnd THEN fmI332 := TfmI332Hnd.Create(Self)
  ELSE
  IF Sender = rbJS  THEN fmI332 := TfmI332JS.Create(Self)
  ELSE
  IF Sender = rbIPL THEN fmI332 := TfmI332IPL.Create(Self)
  ELSE
  IF Sender = rbSP  THEN fmI332 := TfmI332SP.Create(Self)
  ELSE
  IF Sender = rbAS  THEN fmI332 := TfmI332AS.Create(Self)
  ELSE
  IF Sender = rbIO  THEN fmI332 := TfmI332IO.Create(Self)
  ELSE
  IF Sender = rbHR  THEN fmI332 := TfmI332HR.Create(Self)
  ELSE
  IF Sender = rbCNC  THEN fmI332 := TfmI332CNC.Create(Self)
  ELSE
  IF Sender = rbBuffer  THEN fmI332 := TfmI332Buffer.Create(Self)
  ELSE
  ;
  IF Assigned(fmI332) THEN BEGIN
    fmI332.Parent := Self;
    fmI332.Show;
  END;
end;

end.

